# =============================================================
#                CodeTyphon Studio
#      Copyright (c) PilotLogic Software House.
#               All rights reserved.
# =============================================================

docleanall() 
{

if [ -f /usr/bin/fpcmake ] ;
then
  sudo rm -f /usr/bin/fpcmake
fi

if [ -f /usr/bin/${cbTARGETCPUOS}-as ] ;
then
  sudo rm -f /usr/bin/${cbTARGETCPUOS}-as
fi

if [ -d $vfpcdir/newfpc ] ;
then 
  sudo rm -rf $vfpcdir/newfpc
fi

if [ -d $vcodetyphon/binutils ] ;
then    
    sudo rm -rf $vcodetyphon/binutils
fi

if [ -d $vcodetyphon/binutilstemp ] ;
then     
    sudo rm -rf $vcodetyphon/binutilstemp
fi

}

dothejob() 
{

if [ $cbTARGETCPUOS = $cbFPCCPUOS ] ;
then 
  exit
fi

# ================= Remove Android Switchers ======================================

if [ $cbTARGETCPU$cbTARGETOS = armlinux ] ;
then 
 sudo rm -f $vfpcexedir/arm-android.ctss
fi

if [ $cbTARGETCPU$cbTARGETOS = i386linux ] ;
then 
 sudo rm -f $vfpcexedir/i386-android.ctss
fi

# ================= Build cross build tools ======================================

./ln_Cross_Binutils.sh $cbTARGETCPU $cbTARGETOS $cbFPCCPUOS

# ================= Build FPC cross compiler ======================================

echo "====================================================================="
echo "    Build Cross Element for $cbTARGETCPUOS"
echo "====================================================================="
echo "."

# sleep 120

if [ ! -d $vfpcsrcdir ] ;
then   
  echo "???????????????????????????????????????????????????????????"
  echo " [ERROR]:FreePascal Source directory NOT exists"
  echo "         sorry, build STOP " 
  echo "??????????????????????????????????????????????????????????"
  docleanall
  exit
fi

if [ -d $vfpcdir/newfpc ] ;
then     
    echo "[info]: Remove OLD FreePascal temporary build folder..."
    sudo rm -rf $vfpcdir/newfpc
fi

# =======================================================

cd $vfpcsrcdir

echo "------------------------------------------------"
echo "       Clean FreePascal $cbFPCStartEXE" 
echo "------------------------------------------------"
sudo $vmake clean PP=$vfpcbindir/$cbFPCCPUOS/$cbFPCStartEXE

# ------------------- Make Links -------------------------------------
if [ -f $vfpcbindir/$cbFPCCPUOS/fpcmake ] ;
then
  sudo ln -f -s $vfpcbindir/$cbFPCCPUOS/fpcmake /usr/bin/fpcmake
fi

if [ -f $vfpcbindir/$cbFPCCPUOS/${cbTARGETCPUOS}-as ] ;
then 
  sudo ln -f -s $vfpcbindir/$cbFPCCPUOS/${cbTARGETCPUOS}-as /usr/bin/${cbTARGETCPUOS}-as
fi
# -------------------------------------------------------------------

echo "------------------------------------------------"
echo "       Stage 1: Build Cross Compiler Executable" 
echo "------------------------------------------------"

if [ $vosname = solaris ] ;
then   
  sudo $vmake compiler_cycle OPT="-Xn" FPC=$vfpcbindir/$cbFPCCPUOS/$cbFPCStartEXE
  sudo $vmake -C utils/fpcm all OPT="-Xn" FPC=$vfpcbindir/$cbFPCCPUOS/$cbFPCStartEXE
  sudo $vmake all CPU_TARGET=$cbTARGETCPU OS_TARGET=$cbTARGETOS OPT="-Xn" FPC=$vfpcbindir/$cbFPCCPUOS/$cbFPCStartEXE
else  
  sudo $vmake compiler_cycle FPC=$vfpcbindir/$cbFPCCPUOS/$cbFPCStartEXE
  sudo $vmake -C utils/fpcm all FPC=$vfpcbindir/$cbFPCCPUOS/$cbFPCStartEXE
  sudo $vmake all CPU_TARGET=$cbTARGETCPU OS_TARGET=$cbTARGETOS FPC=$vfpcbindir/$cbFPCCPUOS/$cbFPCStartEXE
fi

if [ ! -f $vfpcsrcdir/compiler/$cbFPCCrossEXE ] ;
then  
  echo "???????????????????????????????????????????????????????????"
  echo " [ERROR]:Cross compiler $cbFPCCrossEXE  NOT Builded"
  echo "         sorry, build STOP " 
  echo "??????????????????????????????????????????????????????????"
  docleanall
  exit

else
 sudo cp -f $vfpcsrcdir/compiler/$cbFPCCrossEXE $vfpcbindir/$cbFPCCPUOS/
 sudo chmod -R 777 $vfpcbindir/$cbFPCCPUOS
 echo "."
 echo "[INFO]: !!! Cross compiler Executable $cbFPCCrossEXE, Build OK. !!!"
 echo "."
fi

echo "------------------------------------------------"
echo "       Stage 2: Build All Units and Packages" 
echo "------------------------------------------------"

sudo $vmake -C rtl clean CPU_TARGET=$cbTARGETCPU OS_TARGET=$cbTARGETOS FPC=$vfpcbindir/$cbFPCCPUOS/$cbFPCCrossEXE
sudo $vmake -C packages clean CPU_TARGET=$cbTARGETCPU OS_TARGET=$cbTARGETOS FPC=$vfpcbindir/$cbFPCCPUOS/$cbFPCCrossEXE
sudo $vmake rtl packages CPU_TARGET=$cbTARGETCPU OS_TARGET=$cbTARGETOS FPC=$vfpcbindir/$cbFPCCPUOS/$cbFPCCrossEXE

# sleep 120

echo "------------------------------------------------"
echo "       Stage 3: Install All Units and Packages " 
echo "------------------------------------------------"

sudo $vmake rtl_install packages_install CPU_TARGET=$cbTARGETCPU OS_TARGET=$cbTARGETOS FPC=$vfpcbindir/$cbFPCCPUOS/$cbFPCCrossEXE PREFIX=/usr/lib/codetyphon/fpc/newfpc/ 


echo "------------------------------------------------"
echo "       Stage 4: Copy Files and Units" 
echo "------------------------------------------------"

if [ -d $vfpcdir/newfpc/lib/fpc/$vfpcver/units ] ;
then
 echo "."
 echo "[INFO]: Move FPC Cross compiler units..."
 sudo cp -fr $vfpcdir/newfpc/lib/fpc/$vfpcver/units/* $vfpcdir/units/
fi

echo "------------------------------------------------"
echo "       Clean FreePascal Directory " 
echo "------------------------------------------------"

sudo $vmake clean PP=$vfpcbindir/$cbFPCCPUOS/$cbFPCStartEXE

docleanall

sudo chmod -R 777 $vfpcbindir
sudo chmod -R 777 $vfpcdir

# ===================Final Check ===================================

if [ -d $vfpcdir/units/$cbTARGETCPUOS ] ;
then 
    echo "."
    echo "[FINAL INFO]:-- !!! $cbTARGETCPUOS Cross Build Element Build OK !!! --"
    echo "."
else
    echo "."
    echo " ???????????????????????????????????????????????????????????"
    echo "  [ERROR]: Cross Element for $cbTARGETCPUOS NOT Exists" 
    echo "           sorry, build STOP"
    echo " ???????????????????????????????????????????????????????????"
    echo "." 
fi

}

# =================== MAIN =============================
. $PWD/ln_All_Functions.sh
getvalues

cbFPCType=$1
cbFPCCPUOS=$2
cbFPCStartEXE=$3
cbTARGETCPU=$4
cbTARGETOS=$5
cbFPCCrossEXE=$6
cbTARGETCPUOS=${cbTARGETCPU}-${cbTARGETOS}

echo "-------- Cross Level 1 settings --------"
echo $cbFPCType
echo $cbFPCCPUOS
echo $cbFPCStartEXE
echo $cbTARGETCPU
echo $cbTARGETOS
echo $cbFPCCrossEXE
echo $cbTARGETCPUOS

if [ $cbTARGETCPU = jvm ] ; then  
 ./ln_FPCx_Build_Cross_jvm.sh $cbFPCType $cbFPCCPUOS $cbFPCStartEXE $cbTARGETCPU $cbTARGETOS $cbFPCCrossEXE

elif [ -f ln_FPCx_Build_Cross_${cbTARGETOS}.sh ] ; then  
 ./ln_FPCx_Build_Cross_${cbTARGETOS}.sh $cbFPCType $cbFPCCPUOS $cbFPCStartEXE $cbTARGETCPU $cbTARGETOS $cbFPCCrossEXE

else
 dothejob
fi



