# =============================================================
#                CodeTyphon Studio
#      Copyright (c) PilotLogic Software House.
#               All rights reserved.
# =============================================================

dothejob() 
{

echo "=============================================================="
echo "          Build Lazarus64 Small IDE for $vosrealname"  
echo "=============================================================="

if [ ! -f $vfpcrundir/fpc$vbits ] ;
then  
    echo "[INFO]: FrePascal NOT exist, start FPC building..."  
   ./ln_FPC64_Build.sh
fi

if [ ! -f $vcodetyphon/lazarus/Makefile.fpc ] ;
then    
   ./ln_Lazarus0_Exract_Source_from_ZipFile.sh
fi

# =================== Clear All Settings ===============================

./ln_Lazarus_Settings_Clear.sh

# =================== Prepare ==========================================

if [ ! -d $vcodetyphon/lazarus/bin$vbits ] ;
then   
  sudo mkdir $vcodetyphon/lazarus/bin$vbits
fi

./ln_Lazarus_Settings_Restore.sh

if [ -f $vcodetyphon/lazarus/bin$vbits/slazarus ] ;
then  
 sudo rm -f $vcodetyphon/lazarus/bin$vbits/slazarus
fi

if [ -f $vcodetyphon/lazarus/bin$vbits/CT_Is_BigIDE.ctsw ] ;
then  
 sudo rm -f $vcodetyphon/lazarus/bin$vbits/CT_Is_BigIDE.ctsw
fi

# =================== Build Lazarus64 ==================================

sudo chmod -R 777 $vcodetyphon/lazarus

cd $vcodetyphon/lazarus

if [ $vosname = solaris ] ;
then
 $vmake all OPT="-Xn" PP=$vfpcexedir/$vfpcexec INSTALL_PREFIX=/usr/lib/codetyphon/lazarus/
else

  if [ $vlclplatform = 1 ] ; 
   then
     $vmake all LCL_PLATFORM=qt OPT="-dUSE_QT_45" PP=$vfpcexedir/$vfpcexec INSTALL_PREFIX=/usr/lib/codetyphon/lazarus/
   else
     $vmake all PP=$vfpcexedir/$vfpcexec INSTALL_PREFIX=/usr/lib/codetyphon/lazarus/
   fi

fi

# sleep 120


# ================= Move Bin files ====================================

sudo mv -f lazarus $vcodetyphon/lazarus/bin$vbits/
sudo mv -f startlazarus $vcodetyphon/lazarus/bin$vbits/
sudo mv -f lazbuild $vcodetyphon/lazarus/bin$vbits/

sudo mv -f tools/lazres $vcodetyphon/lazarus/bin$vbits/
sudo mv -f tools/lrstolfm $vcodetyphon/lazarus/bin$vbits/
sudo mv -f tools/svn2revisioninc $vcodetyphon/lazarus/bin$vbits/
sudo mv -f tools/updatepofiles $vcodetyphon/lazarus/bin$vbits/
sudo mv -f tools/apiwizz/apiwizz $vcodetyphon/lazarus/bin$vbits/

# ================= Make Permitions ===================================

sudo chmod -R 777 $vcodetyphon/lazarus

# ================= Strip Bin files ===================================
cd $vcodetyphon/ScriptsLin
./ln_Lazarus_Strip.sh

cd $vcodetyphon/lazarus

# ================= Make links ====================================

echo "."
echo "[INFO]: make some links..."

sudo rm -f $vlazrundir/lazarus-ide$vbits
sudo rm -f $vlazrundir/lazbuild$vbits
sudo rm -f $vlazrundir/startlazarus$vbits

sudo ln -f -s $vcodetyphon/lazarus/bin$vbits/lazarus $vlazrundir/lazarus-ide$vbits
sudo ln -f -s $vcodetyphon/lazarus/bin$vbits/lazbuild $vlazrundir/lazbuild$vbits
sudo ln -f -s $vcodetyphon/lazarus/bin$vbits/startlazarus $vlazrundir/startlazarus$vbits
    
sudo cp -f ../bin/settings/$vname/lazarus$vbits.desktop $vappdskdir/
sudo cp -f ../bin/settings/$vname/lazarus$vbits.xml $vappxmldir/
sudo cp -f ../bin/settings/$vname/lazarus$vbits.png $vapppngdir/ 

sudo cp -f ../bin/settings/$vname/lazarus-ide.1.gz /usr/share/man/man1/
sudo cp -f ../bin/settings/$vname/lazbuild.1.gz /usr/share/man/man1/
sudo cp -f ../bin/settings/$vname/startlazarus.1.gz /usr/share/man/man1/

# ============================ Check Building =============================
echo " "
echo " ------------------------------------------------------"
echo " "
if [ ! -f $vcodetyphon/lazarus/bin$vbits/lazarus ] ;
then    
 echo  "??????????????????????????????????????????????????????"
 echo  "[ERROR]: Sorry, Lazarus64 Small IDE NOT Build"
 echo  "??????????????????????????????????????????????????????"
 sleep 5
else
 echo "[FINAL INFO]: Lazarus64 Small IDE Build OK !!!"  
 echo " "
 sleep 5
fi

}

# =================== MAIN ============================= 
. $PWD/ln_All_Functions.sh
getvalues

if [ $vlclplatform = 1 ] ;
then 
./ln_Lazarus1_Build_QT4pas.sh
fi

if [ $vbits = 64 ] ;
then 
 dothejob
fi



